SystemOrganization addCategory: #'PVpub-AnalogClockPrototype03'!

CircleMorph subclass: #Dial03
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype03'!

!Dial03 commentStamp: 'pv 10/7/2013 21:32' prior: 0!
A Dial03 is a dial with a (visible) midnight watchhand which changes its size according to the size of the dial.

Instance Variables
	watchHand03m:		<Object>

watchHand03m
	- xxxxx
!

!Dial03 methodsFor: 'initialization' stamp: 'pv 12/1/2013 21:18'!
initialize
	| watchHand03m |
	super initialize.
	self extent: 200 @ 200;
		 position: 300 @ 300;
		 layoutPolicy: ConcentricLayout new.
	watchHand03m  := WatchHand03 new.
	watchHand03m
		setInitialMidnightVerticesFromCenter: self center
		andRadius: self extent x / 2
		withFraction: 0.9.
	self
		addMorph: watchHand03m
		fullFrame: (LayoutConcentricFrame
				left: 0.1
				right: 0.1
				top: 0.9
				bottom: 0.1)! !

PolygonMorph subclass: #WatchHand03
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype03'!

!WatchHand03 methodsFor: 'initialization' stamp: 'pv 12/1/2013 21:18'!
setInitialMidnightVerticesFromCenter: aPoint andRadius: aFloat withFraction: aFractionFloat 
	"2013-09-29pv: vertices sind immer Float"
	| lozengeLengthFromCenter lozengeWidthFromCenter midnightVertices |
	lozengeLengthFromCenter := 3 max: aFloat * aFractionFloat.
	lozengeWidthFromCenter := 1 max: aFloat * (1.0 - aFractionFloat).
	midnightVertices :=  Array
				with: aPoint + (0 @ lozengeWidthFromCenter)
				with: aPoint + (-1 * lozengeWidthFromCenter @ 0)
				with: aPoint + (0 @ -1 * lozengeLengthFromCenter)
				with: aPoint + (lozengeWidthFromCenter @ 0).
	self setVertices: midnightVertices! !

!WatchHand03 methodsFor: 'stepping and presenter' stamp: 'pv 10/7/2013 21:26'!
step
	self
		assert: [self referencePosition = self owner center].! !
